## cmtk 2.2.6

=== CMakeLists.txt ===
##
##  Copyright 1997-2010 Torsten Rohlfing
##
##  Copyright 2004-2012 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 4576 $
##
##  $LastChangedDate: 2012-10-29 11:27:19 -0700 (Mon, 29 Oct 2012) $
##
##  $LastChangedBy: torstenrohlfing $
##

##
## This file used to borrow heavily from the analogous InsightToolkit file.
## It may have evolved away since then, however.
##

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.0)
SET(CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required

IF(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW) ## libraries with full paths vs. search paths
ENDIF(COMMAND cmake_policy)
SET(CMAKE_OVERRIDE_COMPILER_MISMATCH 1)

PROJECT(CMTK)
SET(CMTK_VERSION_MAJOR "2")
SET(CMTK_VERSION_MINOR "2")
SET(CMTK_VERSION_PATCH "6")

SET(CMTK_VERSION_STRING "${CMTK_VERSION_MAJOR}.${CMTK_VERSION_MINOR}.${CMTK_VERSION_PATCH}")

#-----------------------------------------------------------------------------
# Test for some required system information.
INCLUDE (${CMAKE_ROOT}/Modules/CMakeDetermineSystem.cmake)
INCLUDE (${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeSystem.cmake)
INCLUDE (${CMAKE_ROOT}/Modules/CMakeBackwardCompatibilityC.cmake)
INCLUDE (${CMAKE_ROOT}/Modules/CMakeBackwardCompatibilityCXX.cmake)

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMake)

#-----------------------------------------------------------------------------
# On Mac, if we have MacPorts installed, we need to look for libraries in 
# /opt/local.

MESSAGE(STATUS "System is " ${CMAKE_SYSTEM})
IF(CMAKE_SYSTEM MATCHES "Darwin.*")
  IF(EXISTS /opt/local)
    LIST(INSERT CMAKE_PREFIX_PATH 0 "/opt/local")
  ENDIF(EXISTS /opt/local)
ENDIF(CMAKE_SYSTEM MATCHES "Darwin.*")

#-----------------------------------------------------------------------------
# Output directories.
IF(NOT LIBRARY_OUTPUT_PATH)
  SET (LIBRARY_OUTPUT_PATH ${CMTK_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all libraries.")
ENDIF(NOT LIBRARY_OUTPUT_PATH)
IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET (EXECUTABLE_OUTPUT_PATH ${CMTK_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)
MARK_AS_ADVANCED(LIBRARY_OUTPUT_PATH EXECUTABLE_OUTPUT_PATH)
IF(NOT CMTK_BUILD_LIB_DIR) # variable used for generating CMTKConfig.cmake for the build tree
  SET(CMTK_BUILD_LIB_DIR "/bin")
ENDIF(NOT CMTK_BUILD_LIB_DIR)

SET(CMTK_LIBRARY_PATH "${LIBRARY_OUTPUT_PATH}")
SET(CMTK_EXECUTABLE_PATH "${EXECUTABLE_OUTPUT_PATH}")
SET(CXX_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})

# set CMTK_DIR so it can be used by subprojects
SET(CMTK_DIR "${CMAKE_BINARY_DIR}" CACHE INTERNAL "CMTK dir to be used by subprojects")

#-----------------------------------------------------------------------------
# Setup install target directories
IF(NOT CMTK_INSTALL_BIN_DIR)
  SET(CMTK_INSTALL_BIN_DIR bin CACHE PATH "Binary files will be installed here")
ENDIF(NOT CMTK_INSTALL_BIN_DIR)

IF(NOT CMTK_INSTALL_LIB_DIR)
  # 64 bit libraries are not installed in the same directories on solaris
  # Ref: http://docs.sun.com/app/docs/doc/816-5138/6mba6ua5m?a=view
  SET(sun64 )
  IF(CMAKE_SYSTEM MATCHES "SunOS.*" AND CMAKE_SIZEOF_VOID_P EQUAL 8)
    EXEC_PROGRAM("uname"
      ARGS "-p"
      OUTPUT_VARIABLE sunproc
    )
    IF("${sunproc}" STREQUAL "sparc")
      SET(sun64 "/sparcv9")
    ENDIF("${sunproc}" STREQUAL "sparc")

    IF("${sunproc}" STREQUAL "i386")
      SET(sun64 "/amd64")
    ENDIF("${sunproc}" STREQUAL "i386")

    IF("${sun64}" STREQUAL "")
      # sun64 is not set - solaris has been ported to a new architecture?
      MESSAGE("Warning: Unknown processor '${sunproc}'. The libraries may not be installed in the right place.")
    ENDIF("${sun64}" STREQUAL "")
  ENDIF(CMAKE_SYSTEM MATCHES "SunOS.*" AND CMAKE_SIZEOF_VOID_P EQUAL 8)

  SET(CMTK_INSTALL_LIB_DIR "lib${sun64}/cmtk" CACHE PATH "Library files will be installed here")
ENDIF(NOT CMTK_INSTALL_LIB_DIR)

IF(NOT CMTK_INSTALL_DATA_DIR)
  SET(CMTK_INSTALL_DATA_DIR "share/cmtk" CACHE PATH "Data files will be installed here")
ENDIF(NOT CMTK_INSTALL_DATA_DIR)

IF(NOT CMTK_INSTALL_INCLUDE_DIR)
  SET(CMTK_INSTALL_INCLUDE_DIR "include/cmtk" CACHE PATH "Data files will be installed here")
ENDIF(NOT CMTK_INSTALL_INCLUDE_DIR)

#-----------------------------------------------------------------------------
# Check for system headers.
INCLUDE (CheckIncludeFiles)
CHECK_INCLUDE_FILES (dirent.h HAVE_DIRENT_H)
CHECK_INCLUDE_FILES (execinfo.h HAVE_EXECINFO_H)
CHECK_INCLUDE_FILES (fcntl.h HAVE_FCNTL_H)
CHECK_INCLUDE_FILES (ieeefp.h HAVE_IEEEFP_H)
CHECK_INCLUDE_FILES (inttypes.h HAVE_INTTYPES_H)
CHECK_INCLUDE_FILES (malloc.h HAVE_MALLOC_H)
CHECK_INCLUDE_FILES (pthread.h HAVE_PTHREAD_H)
CHECK_INCLUDE_FILES (stdint.h HAVE_STDINT_H)
CHECK_INCLUDE_FILES (termios.h HAVE_TERMIOS_H)
CHECK_INCLUDE_FILES (unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILES (values.h HAVE_VALUES_H)

CHECK_INCLUDE_FILES (sys/ioctl.h HAVE_SYS_IOCTL_H)
CHECK_INCLUDE_FILES (sys/procfs.h HAVE_SYS_PROCFS_H)
CHECK_INCLUDE_FILES (sys/stat.h HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES (sys/time.h HAVE_SYS_TIME_H)
CHECK_INCLUDE_FILES (sys/times.h HAVE_SYS_TIMES_H)
CHECK_INCLUDE_FILES (sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES (sys/utsname.h HAVE_SYS_UTSNAME_H)

INCLUDE(TestBigEndian)
TEST_BIG_ENDIAN(WORDS_BIGENDIAN)

#-----------------------------------------------------------------------------
# Test NaN high bit
INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/CMake/TestQnanhibit.cmake)
TEST_QNANHIBIT(QNANHIBIT_VALUE ${CMAKE_CURRENT_SOURCE_DIR}/CMake)
IF(QNANHIBIT_VALUE)
  SET(QNANHIBIT 1 CACHE INTERNAL "The 22nd bit of 32-bit floating-point quiet NaN.")
ELSE(QNANHIBIT_VALUE)
  SET(QNANHIBIT 0 CACHE INTERNAL "The 22nd bit of 32-bit floating-point quiet NaN.")
ENDIF(QNANHIBIT_VALUE)

#-----------------------------------------------------------------------------
# Check for at least one of the typical STL hash map implementations

INCLUDE (CheckIncludeFileCXX)
CHECK_INCLUDE_FILE_CXX(unordered_map HAVE_UNORDERED_MAP)
IF(NOT HAVE_UNORDERED_MAP)
  CHECK_INCLUDE_FILE_CXX(hash_map HAVE_HASH_MAP)
  IF(NOT HAVE_HASH_MAP)
    CHECK_INCLUDE_FILE_CXX(hash_map.h HAVE_HASH_MAP_H)
  ENDIF(NOT HAVE_HASH_MAP)
ENDIF(NOT HAVE_UNORDERED_MAP)

# set a single flag is we have ANY hash map implementation in STL
SET(HAVE_STL_HASH_MAP ${HAVE_UNORDERED_MAP}${HAVE_HASH_MAP}${HAVE_HASH_MAP_H} CACHE INTERNAL "Flag for presence of ANY hash map implementation in the C++ STL")

#-----------------------------------------------------------------------------
# build configuration options.
OPTION(BUILD_SHARED_LIBS "Build CMTK with shared libraries." OFF)
SET(CMTK_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

OPTION(CMTK_BUILD_WRAPPER "Build 'cmtk' wrapper script and install all actual executables in a private directory to avoid name collisions" OFF)
MARK_AS_ADVANCED(CMTK_BUILD_WRAPPER)

OPTION(CMTK_BUILD_UNSTABLE "Build 'unstable' library and tools" OFF)
MARK_AS_ADVANCED(CMTK_BUILD_UNSTABLE)

OPTION(CMTK_BUILD_STACKTRACE "Build tools with stack trace printing in case of crash (increases build time)" ON)
MARK_AS_ADVANCED(CMTK_BUILD_STACKTRACE)

OPTION(CMTK_BUILD_DEMO "Build demonstration code. Strange things will happen if you turn this on." OFF)
MARK_AS_ADVANCED(CMTK_BUILD_DEMO)
IF(CMTK_BUILD_DEMO)
  MESSAGE( WARNING "Demo mode is enabled. Make sure not to use this build for production use!")
ENDIF(CMTK_BUILD_DEMO)

#-----------------------------------------------------------------------------
# Add an option to use or not to use SMP multi-core parallelism

OPTION(CMTK_USE_SMP "Enable shared-memory parallelism (requires at least POSIX Threads, OpenMP, or Windows threads)" ON)

#-----------------------------------------------------------------------------
# Add an option to enable or disable POSIX threads if pthread.h header exists

IF(HAVE_PTHREAD_H)
  OPTION(CMTK_USE_PTHREADS "Use POSIX Threads for SMP parallelism" ON)
  MARK_AS_ADVANCED(CMTK_USE_PTHREADS)

  IF(NOT CMTK_USE_SMP)
    SET(CMTK_USE_PTHREADS OFF)
  ENDIF(NOT CMTK_USE_SMP)
ENDIF(HAVE_PTHREAD_H)

#-----------------------------------------------------------------------------
# for the gnu compiler a -D_PTHREADS is needed on sun
# for the native compiler a -mt flag is needed on the sun
IF(CMTK_USE_PTHREADS)

  IF(${CMAKE_SYSTEM} MATCHES "SunOS.*")
    IF(CMAKE_COMPILER_IS_GNUCXX)
      SET(CMTK_REQUIRED_CXX_FLAGS "${CMTK_REQUIRED_CXX_FLAGS} -D_PTHREADS")
    ELSE(CMAKE_COMPILER_IS_GNUCXX)
      SET(CMTK_REQUIRED_CXX_FLAGS "${CMTK_REQUIRED_CXX_FLAGS} -mt")
      SET(CMTK_REQUIRED_C_FLAGS "${CMTK_REQUIRED_C_FLAGS} -mt")
    ENDIF(CMAKE_COMPILER_IS_GNUCXX)
  ENDIF(${CMAKE_SYSTEM} MATCHES "SunOS.*")
ENDIF(CMTK_USE_PTHREADS)

# mingw thread support
IF(MINGW)
  SET(CMTK_REQUIRED_CXX_FLAGS "${CMTK_REQUIRED_CXX_FLAGS} -mthreads")
  SET(CMTK_REQUIRED_C_FLAGS "${CMTK_REQUIRED_C_FLAGS} -mthreads")
  SET(CMTK_REQUIRED_LINK_FLAGS "${CMTK_REQUIRED_LINK_FLAGS} -mthreads")
ENDIF(MINGW)

#-----------------------------------------------------------------------------
# Check for, and configure, OpenMP

IF(NOT DEFINED CMTK_USE_OPENMP)
  FIND_PACKAGE(OpenMP)
  IF(OPENMP_FOUND)
    OPTION(CMTK_USE_OPENMP "Use OpenMP for SMP parallelism" ON)
    MARK_AS_ADVANCED(CMTK_USE_OPENMP)
    
    IF(NOT CMTK_USE_SMP)
      SET(CMTK_USE_OPENMP OFF)
    ENDIF(NOT CMTK_USE_SMP)
  ENDIF(OPENMP_FOUND)
ENDIF(NOT DEFINED CMTK_USE_OPENMP)

IF(CMTK_USE_OPENMP)
  SET(CMTK_REQUIRED_CXX_FLAGS "${CMTK_REQUIRED_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  SET(CMTK_REQUIRED_LINK_FLAGS "${CMTK_REQUIRED_LINK_FLAGS} ${OpenMP_C_FLAGS}")
ENDIF(CMTK_USE_OPENMP)

#-----------------------------------------------------------------------------
# Check for, and configure, Grand Central Dispatch

CHECK_INCLUDE_FILES(dispatch/dispatch.h HAVE_DISPATCH_H)
IF(HAVE_DISPATCH_H)
  OPTION(CMTK_USE_GCD "Use Grand Central Dispatch for SMP parallelism with system-level load balancing" ON)
  
  IF(NOT CMTK_USE_SMP)
    SET(CMTK_USE_GCD OFF)
  ENDIF(NOT CMTK_USE_SMP)
  
  IF(CMTK_USE_GCD)
  ENDIF(CMTK_USE_GCD)
ENDIF(HAVE_DISPATCH_H)

#-----------------------------------------------------------------------------
# Check for, and configure, CUDA

OPTION(CMTK_USE_CUDA "Use CUDA for GPU computing" OFF)

IF(CMTK_USE_CUDA)
  # check using cmake's own FindCUDA above v2.8 or use our own for earlier versions
  IF (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} STRLESS 2.8)
    INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/CMake/FindCUDA.cmake)
  ELSE (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} STRLESS 2.8)
    FIND_PACKAGE(CUDA)
  ENDIF(${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} STRLESS 2.8)
 
ENDIF(CMTK_USE_CUDA)

#-----------------------------------------------------------------------------
# Check whether compiler supports variable-size automatic arrays, i.e.,
# things like "const int size = 10; const char string[size];" rather than
# "const char string[10];"

INCLUDE(${CMAKE_ROOT}/Modules/CheckCXXSourceCompiles.cmake)
CHECK_CXX_SOURCE_COMPILES("class A {}; class B : public A {}; int main() { int size = 10; B array[size]; }" CMTK_COMPILER_VAR_AUTO_ARRAYSIZE)

#-----------------------------------------------------------------------------

=== apps/CMakeLists.txt ===
##
##  Copyright 1997-2012 Torsten Rohlfing
##
##  Copyright 2004-2012 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 4447 $
##
##  $LastChangedDate: 2012-07-06 13:51:04 -0700 (Fri, 06 Jul 2012) $
##
##  $LastChangedBy: torstenrohlfing $
##

SET(CMTK_LIBRARIES "cmtkSegmentation;cmtkRecon;cmtkRegistration;cmtkIO;cmtkBase;cmtkNumerics;cmtkSystem")
IF(CMTK_BUILD_UNSTABLE)
  SET(CMTK_LIBRARIES "cmtkUnstable;${CMTK_LIBRARIES}")
ENDIF(CMTK_BUILD_UNSTABLE)

SET(APPS avg_adm
  describe
  groupwise_init
  groupwise_affine
  groupwise_warp
  asegment
  average_affine
  average_images
  average_labels
  concat_affine
  convertx
  convert_warp
  destripe
  dof2mat
  dwi_find_bad_slices
  epiunwarp
  fibxform
  fib2image
  film
  filter
  fit_affine_dfield
  fit_affine_xform
  fit_affine_xform_landmarks
  fit_spline_dfield
  fit_spline_xform
  glm
  gmm
  gregxform
  hausdorff
  histogram
  imagemath
  jidb
  levelset
  lsba
  lmsba
  lvote
  make_initial_affine
  mat2dof
  mk_adni_phantom
  mk_analyze_hdr
  mk_nifti_hdr
  mk_phantom_3d
  mrbias
  overlap
  probe
  reformatx
  registration
  registrationx
  regress
  reorient
  sba
  sbai
  sequence
  similarity
  split
  statistics
  streamxform
  sympl
  symplx
  ttest
  unsplit
  unwarp_image_phantom
  volume_injection
  volume_reconstruction
  vtkxform
  warp
  warpx
  warp2ps
  xform2dfield
  xform2itk
  xform2scalar)

IF(CMTK_USE_CUDA)
  SET(CUDA_APPS 
    levelset_cuda
    mrbias_cuda
    symplx_cuda)
ENDIF(CMTK_USE_CUDA)

IF(CMTK_USE_SQLITE)
  LIST(APPEND APPS dbtool)
ENDIF(CMTK_USE_SQLITE)

IF(CMTK_ROOT_PATH_SRI24)
  LIST(APPEND APPS asegment_sri24)
ENDIF(CMTK_ROOT_PATH_SRI24)

IF(HAVE_STL_HASH_MAP)
  LIST(APPEND APPS mcaffine mcwarp)
ENDIF(HAVE_STL_HASH_MAP)

IF(CMTK_USE_DCMTK)
  LIST(APPEND APPS dcm2image)
ENDIF(CMTK_USE_DCMTK)

IF(CMTK_USE_FFTW)
  LIST(APPEND APPS
    detect_spheres_matched_filter
    detect_adni_phantom)
ENDIF(CMTK_USE_FFTW)

FOREACH(APPLICATION ${APPS})
  ADD_EXECUTABLE(${APPLICATION} ${APPLICATION}.cxx)
  TARGET_LINK_LIBRARIES(${APPLICATION} ${CMTK_LIBRARIES} ${CMTK_SYSTEM_LIBRARIES})

  IF(CMTK_BUILD_WRAPPER)
    INSTALL(TARGETS ${APPLICATION} RUNTIME DESTINATION ${CMTK_INSTALL_LIB_DIR}/bin COMPONENT tools)
    SET(manpage cmtk-${APPLICATION}.1)
  ELSE(CMTK_BUILD_WRAPPER)    
    INSTALL(TARGETS ${APPLICATION} RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT tools)
    SET(manpage ${APPLICATION}.1)
  ENDIF(CMTK_BUILD_WRAPPER)
  
  IF(BUILD_MANPAGES)
    ADD_CUSTOM_COMMAND(
      OUTPUT ${manpage}
      COMMAND ${APPLICATION} --man ">" ${manpage}
      DEPENDS ${APPLICATION})
    ADD_CUSTOM_TARGET(man_${APPLICATION} ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${manpage})
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${manpage} DESTINATION share/man/man1 COMPONENT tools)  
  ENDIF(BUILD_MANPAGES)
ENDFOREACH(APPLICATION ${APPS})

FOREACH(APPLICATION ${CUDA_APPS})
  CUDA_ADD_EXECUTABLE(${APPLICATION} ${APPLICATION}.cxx)
  TARGET_LINK_LIBRARIES(${APPLICATION} cmtkGPU ${CMTK_LIBRARIES} ${CMTK_SYSTEM_LIBRARIES})

  IF(CMTK_BUILD_WRAPPER)
    INSTALL(TARGETS ${APPLICATION} RUNTIME DESTINATION ${CMTK_INSTALL_LIB_DIR}/bin COMPONENT tools)
  ELSE(CMTK_BUILD_WRAPPER)    
    INSTALL(TARGETS ${APPLICATION} RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT tools)
  ENDIF(CMTK_BUILD_WRAPPER)
ENDFOREACH(APPLICATION ${CUDA_APPS})

IF(CMTK_USE_CUDA)
  CUDA_ADD_EXECUTABLE(cudatest cudatest.cxx)

  IF(CMTK_BUILD_WRAPPER)
    INSTALL(TARGETS cudatest RUNTIME DESTINATION ${CMTK_INSTALL_LIB_DIR}/bin COMPONENT tools)
  ELSE(CMTK_BUILD_WRAPPER)    
    INSTALL(TARGETS cudatest RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT tools)
  ENDIF(CMTK_BUILD_WRAPPER)
ENDIF(CMTK_USE_CUDA)

=== contrib/CMakeLists.txt ===
##
##  Copyright 2012 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 4473 $
##
##  $LastChangedDate: 2012-08-08 14:51:14 -0700 (Wed, 08 Aug 2012) $
##
##  $LastChangedBy: torsten_at_home $
##

#-----------------------------------------------------------------------------
# Configure third-party contributions.

OPTION(BUILD_CONTRIB_MUNGER "Build, install, and package Greg Jefferis' munger script (requires perl)" OFF)

IF(BUILD_CONTRIB_MUNGER)
  ADD_SUBDIRECTORY(munger)
ENDIF(BUILD_CONTRIB_MUNGER)

=== scripts/CMakeLists.txt ===
##
##  Copyright 2009-2012 SRI International
##
##  Copyright 2012 Torsten Rohlfing
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 4480 $
##
##  $LastChangedDate: 2012-08-10 12:36:46 -0700 (Fri, 10 Aug 2012) $
##
##  $LastChangedBy: torstenrohlfing $
##

## Configure scripts for the build tree
SET(CMTK_BINARY_DIR_CONFIG ${CMAKE_BINARY_DIR}/bin)
SET(CMTK_LIBRARY_DIR_CONFIG ${CMAKE_BINARY_DIR}/bin)

SET(SCRIPTS utilities.sh iterative_shape_averaging correct_nex_motion correct_dwi_distortion correct_dwi_distortion_and_motion groupwise_reformat)
FOREACH(s ${SCRIPTS})
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${s}.in ${CMAKE_BINARY_DIR}/bin/${s} @ONLY)
ENDFOREACH(s ${SCRIPTS})

IF(CMTK_BUILD_WRAPPER)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmtk.in ${CMAKE_BINARY_DIR}/bin/cmtk @ONLY)
ENDIF(CMTK_BUILD_WRAPPER)

## Configure SCRIPTS for the install tree
# Link directories.
IF(CMTK_BUILD_WRAPPER)
  SET(CMTK_BINARY_DIR_CONFIG ${CMAKE_INSTALL_PREFIX}/${CMTK_INSTALL_LIB_DIR}/bin)
ELSE(CMTK_BUILD_WRAPPER)
  SET(CMTK_BINARY_DIR_CONFIG ${CMAKE_INSTALL_PREFIX}/${CMTK_INSTALL_BIN_DIR})
ENDIF(CMTK_BUILD_WRAPPER)

SET(CMTK_LIBRARY_DIR_CONFIG ${CMAKE_INSTALL_PREFIX}/${CMTK_INSTALL_LIB_DIR})

FOREACH(s ${SCRIPTS})
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${s}.in ${CMAKE_BINARY_DIR}/scripts/${s} @ONLY)
  IF(CMTK_BUILD_WRAPPER)
    INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/scripts/${s} DESTINATION ${CMTK_INSTALL_LIB_DIR}/bin COMPONENT tools)
  ELSE(CMTK_BUILD_WRAPPER)
    INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/scripts/${s} DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT tools)
  ENDIF(CMTK_BUILD_WRAPPER)
ENDFOREACH(s ${SCRIPTS})

IF(CMTK_BUILD_WRAPPER)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmtk.in ${CMAKE_BINARY_DIR}/scripts/cmtk @ONLY)
  INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/scripts/cmtk DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT tools)
ENDIF(CMTK_BUILD_WRAPPER)

=== contrib/munger/CMakeLists.txt ===
##
##  Copyright 2012 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 4473 $
##
##  $LastChangedDate: 2012-08-08 14:51:14 -0700 (Wed, 08 Aug 2012) $
##
##  $LastChangedBy: torsten_at_home $
##

FIND_PACKAGE(Perl)

IF(PERL_FOUND)

  ## Configure for the build tree
  SET(CMTK_BINARY_DIR_CONFIG ${CMAKE_BINARY_DIR}/bin)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/munger.in ${CMAKE_BINARY_DIR}/bin/munger @ONLY)

  ## Configure for the install tree
  SET(CMTK_BINARY_DIR_CONFIG ${CMAKE_INSTALL_PREFIX}/${CMTK_INSTALL_BIN_DIR})
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/munger.in ${CMAKE_BINARY_DIR}/scripts/munger @ONLY)
  INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/scripts/munger DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT tools)

ELSE(PERL_FOUND)

  MESSAGE(ERROR "Perl is needed for 'munger' script")

ENDIF(PERL_FOUND)

=== libs/IO/CMakeLists.txt ===
##
##  Copyright 2004-2012 SRI International
##
##  Copyright 1997-2009 Torsten Rohlfing
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 4543 $
##
##  $LastChangedDate: 2012-10-04 12:57:19 -0700 (Thu, 04 Oct 2012) $
##
##  $LastChangedBy: torsten_at_home $
##

# Sources of non-templated classes.
SET(cmtkIO_SRCS
  cmtkAffineXformITKIO.cxx
  cmtkSplineWarpXformITKIO.cxx
  cmtkClassStreamAffineXform.cxx
  cmtkClassStreamParametricPlane.cxx
  cmtkClassStreamStudyList.cxx
  cmtkClassStreamWarpXform.cxx
  cmtkFileFormat.cxx
  cmtkGroupwiseRegistrationFunctionalIO.cxx
  cmtkImageFileDICOM.cxx
  cmtkImageOperationApplyMask.cxx
  cmtkImageStackDICOM.cxx
  cmtkLandmarkIO.cxx
  cmtkLandmarkListIO.cxx
  cmtkPhantomIO_MagphanEMR051.cxx
  cmtkSegmentationLabelIO.cxx
  cmtkSiemensCSAHeader.cxx
  cmtkStudy.cxx
  cmtkStudyList.cxx
  cmtkTypedStream.cxx
  cmtkTypedStreamInput.cxx
  cmtkTypedStreamOutput.cxx
  cmtkTypedStreamStudylist.cxx
  cmtkVolumeFromFile.cxx
  cmtkVolumeFromFileAnalyze.cxx
  cmtkVolumeFromFileBioRad.cxx
  cmtkVolumeFromFileMetaFile.cxx
  cmtkVolumeFromFileNRRD.cxx
  cmtkVolumeFromFileNifti.cxx
  cmtkVolumeFromFileVanderbilt.cxx
  cmtkVolumeFromSlices.cxx
  cmtkVolumeIO.cxx
  cmtkXformIO.cxx
  cmtkXformListIO.cxx
  cmtkXformIONrrd.cxx
)

IF(CMTK_USE_DCMTK)
  SET(cmtkIO_SRCS ${cmtkIO_SRCS} 
    cmtkDICOM.cxx
    cmtkVolumeFromStudy.cxx
    cmtkVolumeFromFileDICOM.cxx)
ENDIF(CMTK_USE_DCMTK)

IF(CMTK_USE_SQLITE)
  SET(cmtkIO_SRCS ${cmtkIO_SRCS} 
    cmtkSQLite.cxx)
ENDIF(CMTK_USE_SQLITE)

ADD_LIBRARY(cmtkIO ${cmtkIO_SRCS})

TARGET_LINK_LIBRARIES(cmtkIO cmtkBase cmtkSystem cmtkNumerics ${NRRD_LIBRARIES} ${CMTK_SQLITE_LIB} ${DCMTK_LIBRARIES} ${CMTK_ZLIB_LIB})

IF(CMTK_LIBRARY_PROPERTIES)
  SET_TARGET_PROPERTIES(cmtkIO PROPERTIES ${CMTK_LIBRARY_PROPERTIES})
ENDIF(CMTK_LIBRARY_PROPERTIES)

INSTALL(TARGETS cmtkIO
  RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT runtime
  LIBRARY DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT runtime
  ARCHIVE DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT libraries)

FILE(GLOB files_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
FILE(GLOB files_txx "${CMAKE_CURRENT_SOURCE_DIR}/*.txx")
INSTALL(FILES ${files_h} ${files_txx} DESTINATION ${CMTK_INSTALL_INCLUDE_DIR}/IO COMPONENT headers)

=== libs/System/CMakeLists.txt ===
##
##  Copyright 1997-2010 Torsten Rohlfing
##
##  Copyright 2004-2012 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 4241 $
##
##  $LastChangedDate: 2012-04-21 14:20:51 -0700 (Sat, 21 Apr 2012) $
##
##  $LastChangedBy: torsten_at_home $
##

# Sources of non-templated classes.
SET(cmtkSystem_SRCS
  cmtkCommandLine.cxx
  cmtkCommandLineCallback.cxx
  cmtkCommandLineItem.cxx
  cmtkCommandLineKeyToAction.cxx
  cmtkCommandLineKeyToActionEnum.cxx
  cmtkCommandLineKeyToActionSingle.cxx
  cmtkCommandLineNonOptionParameter.cxx
  cmtkCommandLineNonOptionParameterVector.cxx
  cmtkCommandLineHelp.cxx
  cmtkCommandLineMan.cxx
  cmtkCommandLineXML.cxx
  cmtkCommandLineWiki.cxx
  cmtkCompressedStream.cxx
  cmtkCompressedStreamFile.cxx
  cmtkCompressedStreamPipe.cxx
  cmtkCompressedStreamReaderBase.cxx
  cmtkCompressedStreamZlib.cxx
  cmtkConsole.cxx
  cmtkFileUtils.cxx
  cmtkMemory.cxx
  cmtkMountPoints.cxx
  cmtkProgress.cxx	
  cmtkProgressConsole.cxx
  cmtkRegressionTracker.cxx
  cmtkStackBacktrace
  cmtkStrUtility.cxx
  cmtkThreads.cxx
  cmtkThreadPoolThreads.cxx
  cmtkThreadSemaphore.cxx
  cmtkTimers.cxx
)

IF(CMTK_USE_BZIP2)
  LIST(APPEND cmtkSystem_SRCS cmtkCompressedStreamBZip2.cxx)
ENDIF(CMTK_USE_BZIP2)

IF(CMTK_USE_LZMA)
  LIST(APPEND cmtkSystem_SRCS cmtkCompressedStreamLZMA.cxx)
ENDIF(CMTK_USE_LZMA)

IF(CMTK_USE_GCD)
  LIST(APPEND cmtkSystem_SRCS cmtkSafeCounterGCD.cxx cmtkThreadPoolGCD.cxx)
ENDIF(CMTK_USE_GCD)

ADD_LIBRARY(cmtkSystem ${cmtkSystem_SRCS})

SET(cmtkSystem_LIBS ${CMTK_BZIP2_LIBS} ${CMTK_LZMA_LIBS} ${CMTK_ZLIB_LIB} ${ZLIB_LIBRARIES} ${MXML_LIBRARIES})
IF(CMTK_USE_FFTW)
  LIST(APPEND cmtkSystem_LIBS ${CMTK_FFTW_LIBRARIES})
ENDIF(CMTK_USE_FFTW)

TARGET_LINK_LIBRARIES(cmtkSystem ${cmtkSystem_LIBS})

IF(CMTK_LIBRARY_PROPERTIES)
  SET_TARGET_PROPERTIES(cmtkSystem PROPERTIES ${CMTK_LIBRARY_PROPERTIES})
ENDIF(CMTK_LIBRARY_PROPERTIES)

INSTALL(TARGETS cmtkSystem
  RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT runtime
  LIBRARY DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT runtime
  ARCHIVE DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT libraries)

FILE(GLOB files_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
FILE(GLOB files_txx "${CMAKE_CURRENT_SOURCE_DIR}/*.txx")
INSTALL(FILES ${files_h} ${files_txx} DESTINATION ${CMTK_INSTALL_INCLUDE_DIR}/System COMPONENT headers)

=== testing/apps/CMakeLists.txt ===
##
##  Copyright 2004-2012 SRI International
##
##  Copyright 1997-2011 Torsten Rohlfing
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 4553 $
##
##  $LastChangedDate: 2012-10-15 16:27:44 -0700 (Mon, 15 Oct 2012) $
##
##  $LastChangedBy: torsten_at_home $
##

FIND_PROGRAM(SH_PATH sh PATHS C:/cygwin/bin)
SET(testDriver ${SH_PATH} ${CMAKE_CURRENT_BINARY_DIR}/appsTestDriver.sh)
SET(testList "")

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/appsTestDriver.sh.in ${CMAKE_CURRENT_BINARY_DIR}/appsTestDriver.sh @ONLY)
# On Windows, remove "\r" (CR) from line ends, which would make Cygwin's sh choke
IF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  EXECUTE_PROCESS(COMMAND c:\\cygwin\\bin\\sed -i.bak s/\\r//g ${CMAKE_CURRENT_BINARY_DIR}/appsTestDriver.sh)
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

# ==========================================
# Tests for "avg_adm" tool
LIST(APPEND testList
  avg_admDefault2
  avg_admDefault3
  avg_admJacobianFloat
  avg_admLabels
  avg_admPaddOutZeroNN
  avg_admNoReferenceModelCubic
  avg_admNoScaleModelAutoScale
  avg_admWithAffineNoRefData)

# ==========================================
# Tests for "dbtool"
IF(CMTK_USE_SQLITE)
  LIST(APPEND testList
    dbtool_AddImages
    dbtool_AddImages2
    dbtool_ListSpace
    dbtool_GetXform1
    dbtool_GetXform2
    dbtool_GetXform3
    dbtool_GetXform4
    dbtool_GetXform5
    dbtool_GetXform6)
ENDIF(CMTK_USE_SQLITE)  

# ==========================================
# Tests for "describe" tool
LIST(APPEND testList
  describeMountPoints
  describeMountPointsMulti
  describeMountPointsPrefix
  describeMountPointsPrefixInvalid
  describeBZip2a
  describeBZip2b
  describeLZMAa 
  describeLZMAb
  describeXZa 
  describeXZb
  describeEmpty
  describeDICOM
  describeMosaicDICOM
  describeMosaicPACSDICOM
  describeDICOMZ
  describeVanderbilt
  describeMR1 
  describeMR2
  describeMR3
  describeMR4
  describeHuman
  describeMRBiorad
  describeMRBioradGz
  describeNiftiDetached348
  describeEmbedAnalyze
  describeEmbedNifti)

IF(CMTK_BUILD_NRRD)
  LIST(APPEND testList
    describeMRNrrd1 
    describeMRNrrd2
    describeNrrdNoOrigin
    describeEmbedNrrd)
ENDIF(CMTK_BUILD_NRRD)

# ==========================================
# Tests for "destripe" tool
LIST(APPEND testList
  destripeDefault
  destripeKernelFloat)

# ==========================================
# Tests for "detect_adni_phantom" tool
IF(CMTK_USE_FFTW)
  LIST(APPEND testList 
    detect_adni_phantomDefault)
ENDIF(CMTK_USE_FFTW)

# ==========================================
# Tests for "detect_spheres_matched_filter" tool
IF(CMTK_USE_FFTW)
  LIST(APPEND testList 
    detect_spheres_matched_filter
    detect_spheres_matched_filterNormalized)
ENDIF(CMTK_USE_FFTW)

# ==========================================
# Tests for "epiunwarp" tool
IF(CMTK_BUILD_NRRD)
  LIST(APPEND testList epiunwarp epiunwarpInitShift)
ENDIF(CMTK_BUILD_NRRD)

# ==========================================
# Tests for "fib2image" tool
LIST(APPEND testList fib2image)

# ==========================================
# Tests for "fibxform" tool
LIST(APPEND testList fibxform fibxformSourceTarget)

# ==========================================
# Tests for "groupwise_init" tool
LIST(APPEND testList
  groupwise_initCenterFOV
  groupwise_initCentersOfMass   
  groupwise_initCentersOfMassScale
  groupwise_initCentersOfMassTemplate)

# ==========================================
# Tests for "groupwise_affine" tool
LIST(APPEND testList
  groupwise_affineFromInit
  groupwise_affineMatchHistograms
  groupwise_affineFromInitSampling
  groupwise_affineBackground 
  groupwise_affineUseTemplate
  groupwise_affineZeroSumSmooth
  groupwise_affineRMIFromInit
  groupwise_affineRMIFromInitDeltaF
  groupwise_affineRMIFromInitSampling 
  groupwise_affineRMIBackground 
  groupwise_affineRMIZeroSumSmooth)

# ==========================================
# Tests for "groupwise_warp" tool
LIST(APPEND testList
  groupwise_warpFromInit
  groupwise_warpFromInitProtect
  groupwise_warpFitFromInit
  groupwise_warpFromInitZeroSum
  groupwise_warpUseTemplate
  groupwise_warpUseTemplateMatchHistograms
  groupwise_warpMatchHistograms
  groupwise_warpFromInitNoBG
  groupwise_warpUseTemplateNoBG
  groupwise_warpRMIFromInit
  groupwise_warpRMIFitFromInit
  groupwise_warpRMIFromInitZeroSum
  )

# ==========================================
# Tests for xml, wiki, man, and help markups
IF(CMTK_USE_SQLITE)
  FOREACH(t film levelset mrbias registration)
    LIST(APPEND testList xml_${t} wiki_${t} man_${t})
  ENDFOREACH(t film levelset mrbias registration)
  LIST(APPEND xml_gmm)
ENDIF(CMTK_USE_SQLITE)

FOREACH(t film)
  LIST(APPEND testList help_${t} help_all_${t})
ENDFOREACH(t film)

# ==========================================
# Tests for "concat_affine" tool
LIST(APPEND testList
  concat_affineABA
  concat_affineABAInvert
  concat_affineAB1A	     
  concat_affineAA1
  concat_affineA1A)

# ==========================================
# Tests for "average_images" tool
LIST(APPEND testList
  average_imagesMean 
  average_imagesMeanNormPadd 
  average_imagesMeanAbsLog 
  average_imagesVariance
  average_imagesStDev
  average_imagesEntropy
  average_imagesZScore)

# ==========================================
# Tests for "convertx" tool
LIST(APPEND testList
  convertxType
  convertxBinarize
  convertxBinarizeOtsu
  convertxBinarizeOtsuNBins
  convertxPruneHighLow
  convertxPruneHigh
  convertxPruneLow
  convertxBoundaryMap
  convertxBoundaryMapMultiValue
  convertxConnectedComponents
  convertxCropThresholdWriteRegion
  convertxCropRegion1
  convertxCropRegion2
  convertxDownsample
  convertxDownsampleSelect
  convertxDistanceUnsigned
  convertxDistanceSigned
  convertxDistanceSigned2
  convertxFlipX
  convertxFlipYZ
  convertxErodeDilateErode
  convertxDilateErodeDilate
  convertxGaussianFilterSigma
  convertxGaussianFilterFWHM
  convertxHistogramEqualization
  convertxHistogramEqualizationNBins
  convertxLaplace
  convertxMapValues
  convertxMapValues2
  convertxMapValues3
  convertxMapValuesOnly
  convertxMapValuesOnly2
  convertxMask
  convertxMaskInverse
  convertxMedianFilter1
  convertxMedianFilter2
  convertxMedianFilterXYZ
  convertxMeanFilter
  convertxFastMean0Filter
  convertxFastMean1Filter
  convertxFastMean2Filter
  convertxFastMean2PadFilter
  convertxVarianceFilter
  convertxFastVariance0Filter
  convertxFastVariance1Filter
  convertxFastVariance2Filter
  convertxFastVariance2PadFilter
  convertxThirdMomentFilter
  convertxStandardDeviationFilter
  convertxSmoothnessFilter
  convertxMedialSkeletonFilter1D
  convertxMedialSkeletonFilter2D
  convertxNiftiToAnalyze
  convertxNiftiToMetaImage
  convertxAnalyzeToNifti
  convertxAnalyzeToNiftiRAS
  convertxNiftiDetachedToNifti
  convertxAnalyzeToNiftiDetached 
  convertxUncompressedNIFTI1
  convertxUncompressedNIFTI2
  convertxUncompressedNIFTI3
  convertxUncompressedNIFTI4
  convertxThresholdBelow
  convertxThresholdAbove
  convertxThresholdBelowToPadding
  convertxThresholdAboveToPadding
  convertxScaleToRange
  convertxRevert
  convertxReplacePadding    
  convertxReplaceInfNaN)

IF(CMTK_BUILD_NRRD)
  LIST(APPEND testList convertxDownsampleNrrd convertxDownsampleSelectNrrd)
ENDIF(CMTK_BUILD_NRRD)

# ==========================================
# Tests for "dcm2image" tool
IF(CMTK_USE_DCMTK)
  LIST(APPEND testList
    dcm2image 
    dcm2imageSubs
    dcm2imageZ
    dcm2imageEmbedPatientNameAnalyze
    dcm2imageEmbedPatientNameNifti
    dcm2imageEmbedSeriesDescriptionNifti
    dcm2imageEmbedStudyIDDateNifti
    dcm2imageEmbedDefaultNifti
    dcm2imageMosaic
    dcm2imageMosaicPACS
    dcm2imageDiffusionGEXML
    dcm2imageDiffusionSiemensXML
    dcm2imageExclude
    dcm2imageInclude
    dcm2imageSubsDirName)
  
  IF(CMTK_BUILD_NRRD)
    LIST(APPEND testList
      dcm2imageNrrd
      dcm2imageEmbedPatientNameNrrd)
  ENDIF(CMTK_BUILD_NRRD)
ENDIF(CMTK_USE_DCMTK)

# ==========================================
# Tests for "dof2mat" tool
LIST(APPEND testList dof2mat dof2matTranspose)

# ==========================================
# Tests for "filter" tool
LIST(APPEND testList
  filterGaussian
  filterGaussianSmallKernel
  filterGaussianNoFilter
  filterRohlfing)

# ==========================================
# Tests for "film" tool
LIST(APPEND testList
  filmCubic
  filmFourthOrder
  filmMSDLinearNoTrunc
  filmMISincRefSPGR)


# ==========================================
# Tests for "fit_affine_xform_landmarks" tool
LIST(APPEND testList fit_affine_xform_landmarksRigid fit_affine_xform_landmarksScales fit_affine_xform_landmarksShear
  fit_affine_xform_landmarksRigidRigid fit_affine_xform_landmarksRigidRigidFlip fit_affine_xform_landmarksRigidScales fit_affine_xform_landmarksRigidShear)

# ==========================================
# Tests for "fit_affine_xform" tool
LIST(APPEND testList fit_affine_xform fit_affine_xformRigid fit_affine_xformReverse)

# ==========================================
# Tests for "fit_affine_dfield" tool
LIST(APPEND testList fit_affine_dfieldFFD)
IF(CMTK_BUILD_NRRD)
  LIST(APPEND testList fit_affine_dfieldDField)
ENDIF(CMTK_BUILD_NRRD)

# ==========================================
# Tests for "fit_spline_dfield" tool
IF(CMTK_BUILD_NRRD)
  LIST(APPEND testList
    fit_spline_dfieldSpacing
    fit_spline_dfieldSpacingMultiLevel
    fit_spline_dfieldDims
    fit_spline_dfieldDimsRelative
    fit_spline_dfieldDimsMultiLevel
    fit_spline_dfieldDimsMultiLevelSafe
    fit_spline_dfieldDimsWithAffine)
ENDIF(CMTK_BUILD_NRRD)

# ==========================================
# Tests for "fit_spline_xform" tool
LIST(APPEND testList fit_spline_xformSpacing fit_spline_xformSpacingReverse fit_spline_xformSpacingMultiLevel fit_spline_xformDims fit_spline_xformDimsMultiLevel)

# ==========================================
# Tests for "glm" tool
LIST(APPEND testList
  glmDefault glmNormalize glmExp glmNoConstant glmIgnore glmSelect glmCrop)

# ==========================================
# Tests for "gmm" tool
LIST(APPEND testList gmmDefault gmmAlternative)

# ==========================================
# Tests for "gregxform" tool
LIST(APPEND testList
  gregxformFordwardBackward 
  gregxformAffine 
  gregxformAffineFromWarp
  gregxformAffineFromWarpFwdBwd)

# ==========================================
# Tests for "hausdorff" tool
LIST(APPEND testList
  hausdorffBinary12
  hausdorffBinary21
  hausdorffBinaryForced)

# ==========================================
# Tests for "histogram" tool
LIST(APPEND testList
  histogram 
  histogramNorm
  histogramBinsMinMax
  histogramBinsMinMaxTrunc
  histogramMask)

# ==========================================
# Tests for "imagemath" tool
LIST(APPEND testList
  imagemathAbsPop
  imagemathSqrSqrt
  imagemathLogExp
  imagemathDupAddMulDiv
  imagemathThreshAboveBelow
  imagemathAverage 
  imagemathVariance
  imagemathMaskAverage 
  imagemathXor
  imagemathDupFillMaxValue
  imagemathAnd
  imagemathContractLabels
  imagemathMaxIndex
  imagemathMaxValue
  imagemathStackEntropyLabels
  imagemathVote
  imagemathProduct
  imagemathSTAPLE
  imagemathMultiClassSTAPLE 
  imagemathMultiClassDisputedSTAPLE 
  imagemathCombinePCA
  imagemathT2
  imagemathAtan2

=== debian/changelog ===
cmtk (2.2.6-1~nd11.10+1) oneiric; urgency=low

  * Backported for oneiric.
  * Added 'series-oneiric' in quilt patch series.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Mon, 29 Oct 2012 23:36:11 -0400

cmtk (2.2.6-1) experimental; urgency=low

  * New upstream release
    - includes freshier snapshot or nrrdio
    - addresses segfaults in dcm2image

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 29 Oct 2012 19:16:13 -0400

cmtk (2.2.5-1) UNRELEASED; urgency=low

  * New upstream release
    - addresses bashism issues (Closes: #690930)

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 23 Oct 2012 13:33:47 -0400

cmtk (2.2.4-1) experimental; urgency=low

  * New upstream bugfix release

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 24 Aug 2012 19:45:29 -0400

cmtk (2.2.3-1) experimental; urgency=low

  * New upstream release
    - incorporates compatibility changes for older fftw (patch dropped)
    - requires mxml >= 2.7.  Copy of it is now shipped along under
      Utilities/mxml -- amd built against when system-wide version is
      outdated.
  * debian/copyright:
    - added entry for Greg Jefferis's contributions

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 10 Aug 2012 20:18:46 -0400

cmtk (2.2.2-2) unstable; urgency=low

  * Adding libfftw3-dev into build-depends and adding
    CMTK_USE_FFTW:BOOL=ON for cmake.  Should make detect_adni_phantom
    referenced in a publication available.
    - for backports to older releases (e.g. squeeze) compatibility patch
      up_compat_older_fftw is provided and added to corresponding series
  * Added debian/upstream with a publication reference (added to debian/docs)

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 18 Jul 2012 13:03:08 -0400

=== debian/control ===
Source: cmtk
Section: science
Priority: extra
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 7.0.50~),
               cmake,
               libmxml-dev,
               libsqlite3-dev,
               zlib1g-dev | libz-dev,
               libdcmtk2-dev | libdcmtk1-dev | libdcmtk-dev,
               libbz2-dev,
               libfftw3-dev,
               liblzma-dev,
               libqt4-dev, qt4-qmake,
               libpng-dev,
               libtiff4-dev | libtiff-dev,
               libwrap0-dev,
               libcharls-dev | libdcmtk1-dev | libdcmtk2-dev (<< 3.6.0-8~),
               libxml2-dev,
               libssl-dev,
               xvfb,
               xauth,
Standards-Version: 3.9.3
Homepage: http://www.nitrc.org/projects/cmtk/
Vcs-Git: git://git.debian.org/pkg-exppsy/cmtk.git
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/cmtk.git;a=summary


Package: cmtk
Architecture: any
Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
Recommends: sri24-atlas
Suggests: numdiff
Description: Computational Morphometry Toolkit
 A software toolkit for computational morphometry of biomedical
 images, CMTK comprises a set of command line tools and a back-end
 general-purpose library for processing and I/O.
 .
 The command line tools primarily provide the following functionality:
 registration (affine and nonrigid; single and multi-channel; pairwise
 and groupwise), image correction (MR bias field estimation;
 interleaved image artifact correction), processing (filters;
 combination of segmentations via voting and STAPLE; shape-based
 averaging), statistics (t-tests; general linear regression).
